r68: jos ispravaka cp_check_and_sed + changelog
[carnet-tools-cn.git] / functions.sh
1 # by ddzeko & ico, Fri, 18 Mar 2005 14:44:08 +0100
2 cp_get_ifaddr() {
3   [ "$CP_SCRIPT_DEBUG" ] && set -vx
4   local ifaddr interface echo_return
5   echo_return="$CP_ECHO_RETURN" # since we're making our own calls
6   # in our own way we need to set CP_ECHO_RETURN the way we want it
7   # but preserving initial state so it could be used afterwards
8   CP_ECHO_RETURN=""
9
10   interface="$1"
11   if [ -z "$interface" ]; then
12     cp_get_ifdefault dev
13     interface="$RET"
14     [ -z "$interface" ] && interface=lo
15   fi
16
17   if ! ifconfig $interface 2> /dev/null >> /dev/null; then
18     echo "cp_get_ifaddr: $interface: No such interface" 1>&2
19     CP_ECHO_RETURN="$echo_return"
20     return 2
21   fi
22
23   ifaddr="`/sbin/ifconfig $interface | awk '/inet/{ printf("%s\n",substr($2,index($2,":")+1)) }'`"
24
25   if [ -z $ifaddr ]; then
26     echo "cp_get_ifaddr: $interface: No ip address found" 1>&2
27     CP_ECHO_RETURN="$echo_return"
28     return 1
29   fi
30
31   RET="$ifaddr"
32   [ -z "$echo_return" ] || echo $RET
33   CP_ECHO_RETURN="$echo_return"
34 }
35
36 # by ddzeko & ico, Fri, 18 Mar 2005 14:44:08 +0100
37 cp_get_ifmask() {
38   [ "$CP_SCRIPT_DEBUG" ] && set -vx
39   local ifmask interface echo_return
40   echo_return="$CP_ECHO_RETURN" # since we're making our own calls
41   # in our own way we need to set CP_ECHO_RETURN the way we want it
42   # but preserving initial state so it could be used afterwards
43   CP_ECHO_RETURN=""
44
45   interface="$1"
46   if [ -z "$interface" ]; then
47     cp_get_ifdefault dev
48     interface="$RET"
49     [ -z "$interface" ] && interface=lo
50   fi
51
52   if ! ifconfig $interface 2> /dev/null >> /dev/null; then
53     echo "cp_get_ifmask: $interface: No such interface" 1>&2
54     CP_ECHO_RETURN="$echo_return"
55     return 1
56   fi
57
58   ifmask="`/sbin/ifconfig $interface | awk '/Mask/{if($3~/Mask/)a=$3;else if ($4~/Mask/)a=$4;printf ("%s\n", substr(a,index(a,":")+1))}'`"
59
60   if [ -z "$ifmask" ]; then
61     echo "cp_get_ifmask: $interface: No netmask found" 1>&2
62     CP_ECHO_RETURN="$echo_return"
63     return 1
64   fi
65
66   RET="$ifmask"
67   [ -z "$echo_return" ] || echo $RET
68   CP_ECHO_RETURN="$echo_return"
69 }
70
71 # by ddzeko, Mon, 21 Mar 2005 07:00:22 +0100
72 cp_get_ifdefault() {
73   local echo_return
74   echo_return="$CP_ECHO_RETURN" # since we're making our own calls
75   # in our own way we need to set CP_ECHO_RETURN the way we want it
76   # but preserving initial state so it could be used afterwards
77   CP_ECHO_RETURN=""
78
79   [ "$CP_SCRIPT_DEBUG" ] && set -vx
80   RET=""
81   case $1 in
82     dev)  RET=`route -n | awk '/^0.0.0.0/{print $8}'` ;;
83     addr) RET=`route -n | awk '/^0.0.0.0/{print $2}'` ;;
84     *)    echo "cp_get_ifdefault: Argument required (dev or addr)" >&2 ;;
85   esac
86   [ -z "$RET" -a "$1" ] && echo "cp_get_ifdefault: No default route" >&2
87   [ -z "$echo_return" ] || echo $RET
88   CP_ECHO_RETURN="$echo_return"
89   [ -z "$RET" ] && return 1
90 }
91
92 # by ico, Tue, 15 Mar 2005 14:04:21 +0100
93 cp_get_netaddr() {
94   [ "$CP_SCRIPT_DEBUG" ] && set -vx
95   local netmask ipaddress interface cidr echo_return
96   echo_return="$CP_ECHO_RETURN" # since we're making our own calls
97   # in our own way we need to set CP_ECHO_RETURN the way we want it
98   # but preserving initial state so it could be used afterwards
99   CP_ECHO_RETURN=""
100
101   interface="$1"
102   if [ -z "$interface" ]; then
103     cp_get_ifdefault dev
104     interface="$RET"
105     [ -z "$interface" ] && interface=lo
106   fi
107
108   if ! ifconfig $interface 2> /dev/null >> /dev/null; then
109     echo "cp_get_netaddr: $interface: No such interface" 1>&2
110     CP_ECHO_RETURN="$echo_return"
111     return 1
112   fi
113
114   cp_get_ifaddr "$interface"
115   ipaddress="$RET"
116   if [ -z $ipaddress ]; then
117     echo "cp_get_netaddr: $interface: No IP address found" 1>&2
118     CP_ECHO_RETURN="$echo_return"
119     return 1
120   fi
121   cp_get_ifmask "$interface"
122   netmask="$RET"
123   if [ -z $netmask ]; then
124     echo "cp_get_netaddr: $interface: No netmask found" 1>&2
125     CP_ECHO_RETURN="$echo_return"
126     return 1
127   fi
128
129   if [ "$netmask" = "255.255.255.255" ]; then
130     cidr="$ipaddress/32"
131   else 
132     cidr="`ipcalc -ncb $ipaddress $netmask | awk '/^Network:/{print $2}'`"
133   fi
134   
135   RET="$cidr"
136   [ -z "$echo_return" ] || echo $RET
137   CP_ECHO_RETURN="$echo_return"
138 }
139
140 cp_check_and_backup() {
141   cp_backup_conffile -r "$@"
142 }
143
144 # by ico, Tue, 15 Mar 2005 14:04:21 +0100
145 cp_backup_conffile() {
146   [ "$CP_SCRIPT_DEBUG" ] && set -vx
147   local file_bak check did
148   
149   if [ "x$1" = "x-r" ]; then
150     check=1
151     shift
152   fi
153   if [ -z "$1" ]; then
154     return 1
155   fi
156   if [ ! -f "$1" ]; then
157     echo "cp_backup_conffile: $1: No such file" 1>&2
158     return 2
159   fi
160   if [ -z "$2" ]; then
161     file_bak="/var/backups/`basename $1`.bak"
162   else
163     file_bak="/var/backups/`basename $2`.bak"
164   fi
165
166   if [ ! -f "$file_bak" ]; then
167     cp -pf "$1" "$file_bak"
168     did=1
169   else
170     if ! cmp -s "$1" "$file_bak"; then
171       /usr/bin/savelog -p -c 7 "$file_bak" > /dev/null 2> /dev/null
172       cp -pf "$1" "$file_bak"
173       did=1
174     fi
175   fi
176   
177   if [ "$check" -a "$did" ]; then
178     return 0
179   else
180     return 3
181   fi
182 }
183
184 # by jelly, Tue, 15 Mar 2005 14:04:21 +0100
185 # modified by ico, Mon,  6 Jun 2005 11:58:08 +0200
186 # A sed wrapper, to use instead of perl -pi -e
187 #  - relatively safe in-place s///g
188 #  - takes care of symlinks and ownership
189 # returns true if changed, false if nothing happened
190 #
191 cp_check_and_sed() {
192   [ "$CP_SCRIPT_DEBUG" ] && set -vx
193   local s sedcmd grepret ret i
194   if [ -z "$3" ]; then
195     echo "Usage: cp_check_and_sed <regexp> <sed> <file> [file ...]" 2>&1 
196     return 1
197   fi
198   s="$1"
199   shift
200   sedcmd="$1"
201   shift
202   ret=2
203   for i in "$@"
204   do
205     [ -e "$i" ]        || continue
206     if ! egrep -q "$s" "$i"; then
207       grepret=1
208       continue
209     fi
210     [ -h "$i" ]        && i=$(readlink -f "$i")
211     sed "$sedcmd" "$i" > "$i.dpkg-tmp"
212     if [ ! "$?" = "0" ]; then
213       rm "$i.dpkg-tmp"
214       echo "cp_check_and_sed: Problem with sed" 1>&2
215       return 5
216     fi
217     if ! cmp -s "$i" "$i.dpkg-tmp" 2>&1 >/dev/null; then
218       cp_mv "$i.dpkg-tmp" "$i"
219     else
220       rm "$i.dpkg-tmp"
221     fi
222     ret=0
223   done
224   [ "$ret" -eq 2 -a "$grepret"] && ret=1 || true
225   return $ret
226 }
227
228 # by jelly, Sun, 20 Mar 2005 20:12:19 +0100
229 cp_echo () {
230   [ "$CP_SCRIPT_DEBUG" ] && set -vx
231   if [ "x$1" = "x-mailonly" -o "x$1" = "x-m" ]; then
232     shift
233   else   
234     echo "$*"
235   fi
236   CP_NOTICE="$CP_NOTICE$1"
237   if [ `echo -n "$*" | wc -l` -eq 0 ]; then
238     CP_NOTICE="$CP_NOTICE
239 "
240   fi
241 }   
242
243 # by jelly, Sun, 20 Mar 2005 20:12:19 +0100
244 cp_mail () {
245   [ "$CP_SCRIPT_DEBUG" ] && set -vx
246   local pkg version quiet
247   if [ "x$1" = "x-q" ]; then
248     quiet=1
249     shift
250   fi
251   [ -n "$1" ] && pkg="$1"       # barf if no package
252   [ -n "$2" ] && version=" $2" || true
253   if [ "$(echo $CP_NOTICE|wc -w)" -gt 0 ]; then
254     [ -n "$quiet" ] || echo "Mailing upgrade output to root."
255     CP_NOTICE="From: $pkg postinst script <root>
256 To: root
257 Subject: $pkg$version package install log
258 Date: $(/bin/date +'%a, %d %b %Y %H:%M:%S %z')
259  
260 Hello!
261
262 The $pkg package has been successfully installed on your computer.
263 For your convenience, a partial output of the last $pkg installation
264 is included below.
265
266 ----------
267 ${CP_NOTICE}----------"
268   
269     echo "$CP_NOTICE" | /usr/sbin/sendmail -t &
270     sleep 1
271   fi
272 }
273
274 # by ddzeko, Mon, 21 Mar 2005 11:31:59 +0100
275 cp_mv () {
276   [ "$CP_SCRIPT_DEBUG" ] && set -vx
277   local new old
278   if [ -z "$2" ]; then
279     return 1
280   fi
281   new="$1"
282   old="$2"
283   if [ -e "$old" ]; then
284     chown --reference "$old" "$new"
285     chmod --reference "$old" "$new"
286   fi
287   mv "$new" "$old"
288 }
289
290 # by ddzeko, Mon, 21 Mar 2005 13:35:42 +0100
291 cp_yes_no () {
292   [ "$CP_SCRIPT_DEBUG" ] && set -vx
293   local prompt answer
294   prompt="$1"
295   [ "$prompt" ] || prompt="Are you sure?"
296   RET=""
297
298   # check to prevent user from using this when debconf is active
299   # (it would break communication with its backend - uses stdin/out)
300   if [ "$DEBCONF_REDIR" ]; then
301     echo "cp_yes_no: debconf redirection detected" >&2
302     return 1
303   fi
304
305   echo -n "$prompt (y)es/(n)o: "
306   read answer
307   case "$answer" in
308     y*)
309       echo
310       RET=y
311       ;;
312     n*)
313       echo
314       RET=n
315       ;;
316     *)
317       echo
318       echo "Please read the message and choose y or n"
319       cp_yes_no
320       ;;
321   esac
322 }
323
324 # by ddzeko, Tue, 29 Mar 2005 17:37:52 +0200
325 #
326 # db_get seems to return error messages if the requested variable 
327 # is not found - we do not find that desirable, and checking $? with
328 # set -e turned on seems to be a bit of a problem
329 # --> that's why we wrap the db_get call to return unset RET variable
330 #     instead of some gibberish error message that our script does
331 #     not expect
332 cp_db_get() {
333   local var
334   var="$1"
335   
336   # check to prevent user from using this before activating debconf
337   # confmodule needs to be loaded before accessing db_* functions
338   if [ -z "$DEBCONF_REDIR" ]; then
339     echo "cp_db_get: debconf not activated!" >&2
340     return 1
341   fi
342  
343   if ! db_get "$var"; then
344     case "$RET" in
345         *doesn\'t\ exist)
346           RET=""
347           ;;
348         [0-9][0-9]\ ?*) # other errors
349           RET=""
350           ;;
351     esac
352   fi
353 }
354
355 # by ico, Wed, 20 Apr 2005 21:09:54 +0200
356 cp_get_ldap_suffix() {
357   local echo_return
358   echo_return="$CP_ECHO_RETURN" # since we're making our own calls
359   # in our own way we need to set CP_ECHO_RETURN the way we want it
360   # but preserving initial state so it could be used afterwards
361   CP_ECHO_RETURN=""
362
363   [ "$CP_SCRIPT_DEBUG" ] && set -vx
364
365   if [ ! -f /etc/ldap/slapd.conf ]; then
366     echo "cp_get_ldap_suffix: /etc/ldap/slapd.conf: No such file" >&2
367     return 2
368   fi
369   
370   RET="`awk  '/^suffix/      { exit }
371               END            { gsub(/"/, "", $2); print $2 }' \
372              < /etc/ldap/slapd.conf`"
373
374   if [ "`echo $RET | sed 's/,/ /g' | wc -w`" -gt 2 ]; then
375     RET=""
376     echo "cp_get_ldap_suffix: Invalid LDAP suffix in /etc/ldap/slapd.conf" >&2
377     return 2
378   fi
379     
380   [ -z "$RET" ] && echo "cp_get_ldap_suffix: No LDAP suffix in /etc/ldap/slapd.conf" >&2
381   [ -z "$echo_return" ] || echo $RET
382   CP_ECHO_RETURN="$echo_return"
383 }
384
385 # by ico, Wed, 20 Apr 2005 21:09:54 +0200
386 cp_get_ldap_realm() {
387   local echo_return
388   echo_return="$CP_ECHO_RETURN" # since we're making our own calls
389   # in our own way we need to set CP_ECHO_RETURN the way we want it
390   # but preserving initial state so it could be used afterwards
391   CP_ECHO_RETURN=""
392
393   [ "$CP_SCRIPT_DEBUG" ] && set -vx
394
395   if [ ! -f /etc/ldap/slapd.conf ]; then
396     echo "cp_get_ldap_realm: /etc/ldap/slapd.conf: No such file" >&2
397     return 2
398   fi
399  
400   cp_get_ldap_suffix || true
401   RET="`echo $RET | awk -F, '{print $1}' | awk -F= '{print $2}'`"
402
403   [ -z "$RET" ] && echo "cp_get_ldap_realm: No LDAP REALM in /etc/ldap/slapd.conf" >&2
404   [ -z "$echo_return" ] || echo $RET
405   CP_ECHO_RETURN="$echo_return"
406 }
407